var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import Button from '@material-ui/core/Button';
import CircularProgress from '@material-ui/core/CircularProgress';
import ExportIcon from '@material-ui/icons/CloudDownload';
import { exportPaginatedDataToCsv } from '../utils/csvExport';
var CsvExporter = function (_a) {
    var filename = _a.filename, queryData = _a.queryData;
    var _b = React.useState({ exporting: false, proceed: 0, total: 0 }), progress = _b[0], setProgress = _b[1];
    var doProgress = React.useCallback(function (proceed, total, done) {
        if (done) {
            setProgress(function (r) { return (__assign(__assign({}, r), { exporting: false })); });
        }
        else {
            setProgress(function (r) { return (__assign(__assign({}, r), { proceed: proceed, total: total })); });
        }
    }, [setProgress]);
    var exportHandler = function () {
        var _a, _b;
        if ((_b = (_a = queryData.currentPage) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.length) {
            setProgress(function (r) { return (__assign(__assign({}, r), { exporting: true, total: 1 })); });
            exportPaginatedDataToCsv(queryData.suggestFilename(), queryData, doProgress);
        }
    };
    return React.createElement(React.Fragment, null,
        !progress.exporting && React.createElement(Button, { onClick: exportHandler },
            React.createElement(ExportIcon, null)),
        progress.exporting && React.createElement(CircularProgress, { variant: "determinate", value: progress.proceed / progress.total }));
};
export default CsvExporter;
